// DSTIH.cpp : Implementation of CDSTIH

#include "stdafx.h"
#include "DSTIH.h"

// CDSTIH
#include <strsafe.h>

#pragma comment (lib, "gdiplus.lib")

// CDSTIH
CDSTIH::CDSTIH()
{
	m_szPNGFileName[0] = '\0';

	// Start GDI+
	Gdiplus::GdiplusStartupInput gdiplusStartupInput;
	Gdiplus::GdiplusStartup (&m_gdiplusToken, &gdiplusStartupInput, NULL);
}

CDSTIH::~CDSTIH()
{
	// Stop GDI+
	Gdiplus::GdiplusShutdown (m_gdiplusToken);
}

STDMETHODIMP CDSTIH::Initialize (LPCWSTR pssFilePath, DWORD grfMode)
{
	UNREFERENCED_PARAMETER (grfMode);

	HRESULT result = HRESULT_FROM_WIN32(ERROR_ALREADY_INITIALIZED);

	// If not already initialized, generate and save the PNG filename
	if (m_szPNGFileName[0] == NULL)
	{
		// Generate png filename
		result = StringCchCopy (m_szPNGFileName, ARRAYSIZE(m_szPNGFileName), pssFilePath);
		if (FAILED(result))
			goto failure;

		result = StringCchCat (m_szPNGFileName, ARRAYSIZE(m_szPNGFileName), _T(".png"));
		if (FAILED(result))
			goto failure;
	}

failure:
	return result;
}

STDMETHODIMP CDSTIH::GetThumbnail (UINT cx, HBITMAP *phbmp, WTS_ALPHATYPE* pdwAlpha)
{
	UNREFERENCED_PARAMETER (cx);

	HRESULT result = E_FAIL;

	// Load file to make icon from
	Gdiplus::Bitmap bitmap (m_szPNGFileName);
	if (bitmap.GetLastStatus() == Gdiplus::Ok)
	{
		result = bitmap.GetHBITMAP (Gdiplus::Color(), phbmp);
		if (FAILED(result))
			goto failure;

		*pdwAlpha = WTSAT_ARGB;
	}

failure:
	return result;
}